/* Copyright (C) 1996,1997,1998,1999 by Salvador E. Tropea (SET),
   see copyrigh file for details */
#include <stdio.h>
#include <string.h>

#define Uses_TCEditor_Internal
#define Uses_TCEditor_External
#define Uses_TCEditor
#include <ceditor.h>

static stkHandler *ConvTable=0;

extern Boolean SETSECreateTables(strSETSE &st, int CaseSens,
                                 TNoCaseSOSStringCollection *TSC);

static void ReplaceCRby0(char *s)
{
 for (; *s && *s!='\n' && *s!='\r'; s++);
 *s=0;
}

static char *MoveAfterEqual(char *s)
{
 for (; *s && *s!='='; s++);
 if (*s) s++;
 for (; *s && ucisspace(*s); s++);
 return s;
}

static void GetUpTo(int len, char *s, char *d, int &l)
{
 for (l=0; *s && *s!='\n' && *s!='\r' && l<len; s++,l++) d[l]=*s;
}

static void FillTableWith(char *s, ushort *t, int mask)
{
 for (; *s && *s!='\n' && *s!='\r'; s++) t[*s]|=mask;
}

int SHLConvValToPos(int a)
{
 if (!ConvTable) return a;
 return ConvTable[a];
}

int SHLConvPosToVal(int a)
{
 int i=0;

 if (!ConvTable) return a;
 while (ConvTable[i]!=(unsigned)a) i++;
 return i;
}

static void PutInTables(int len, char *s, unsigned flag, ushort *Table, int Case)
{
 int i;

 if (len)
   {
    if (!Case)
      {
       for (i=0; i<len; i++)
           s[i]=uctoupper(s[i]);
       Table[uctolower(*s)]|=flag;
      }
    Table[*s]|=flag;
   }
}

int LoadSyntaxHighLightFile(char *name, strSHL *&hl, SOStack &so,
                            TNoCaseSOSStringCollection *list,int &Cant)
{
 FILE *f;
 char b[maxSHLFileWidth];
 int  defs,def,end,i,isCase;
 char *pos,*s;

 Cant=0;
 if ((f=fopen(name,"rb"))==NULL)
    return 1;

 // Meassure the number of definitions
 for (defs=0; !feof(f); )
    {
     fgets(b,maxSHLFileWidth,f);
     if (!feof(f) && strncasecmp(b,"End",3)==0)
        defs++;
    }

 Cant=defs;
 if (!defs)
    return 2;

 // Allocate enough memory
 hl=new strSHL[defs];
 if (!hl)
    return 3;
 memset(hl,0,sizeof(strSHL)*defs);
 ConvTable=new stkHandler[defs];
 if (!ConvTable)
    return 3;

 // Load and parse all
 rewind(f);
 for (def=0; def<defs && !feof(f); def++)
    {
     hl[def].Keywords=new TNoCaseSOSStringCollection(84,12,&so);
     hl[def].PMacros=stkNULL;
     hl[def].PM=0;
     hl[def].Flags1=0;
     isCase=0;
     if (!hl[def].Keywords)
        return 3;
     for (i=0; i<256; i++)
         if (ucisalnum(i) || i=='_')
            hl[def].SymbolT[i]|=shl_INSNAME | shl_BEGNAME;
     do
       {
        do
          {
           fgets(b,maxSHLFileWidth,f);
          }
        while (*b=='#' || ucisspace(*b));

        if (strncasecmp(b,"Name",4)==0)
          {
           pos=MoveAfterEqual(b);
           ReplaceCRby0(pos);
           list->insert(ConvTable[def]=so.addStr(pos));
          }
        else
        if (strncasecmp(b,"Files",5)==0)
          {
           pos=MoveAfterEqual(b);
           ReplaceCRby0(pos);
           hl[def].Extentions=so.addStr(pos);
          }
        else
        if (strncasecmp(b,"OpenComment1",12)==0)
          {
           pos=MoveAfterEqual(b);
           GetUpTo(4,pos,hl[def].OpenCom1,hl[def].lOpenCom1);
           PutInTables(hl[def].lOpenCom1,hl[def].OpenCom1,shl_OPC1,hl[def].SymbolT,isCase);
          }
        else
        if (strncasecmp(b,"CloseComment1",13)==0)
          {
           pos=MoveAfterEqual(b);
           GetUpTo(4,pos,hl[def].CloseCom1,hl[def].lCloseCom1);
           PutInTables(hl[def].lCloseCom1,hl[def].CloseCom1,shl_CLOSE1,hl[def].SymbolT,isCase);
          }
        else
        if (strncasecmp(b,"OpenComment2",12)==0)
          {
           pos=MoveAfterEqual(b);
           GetUpTo(4,pos,hl[def].OpenCom2,hl[def].lOpenCom2);
           PutInTables(hl[def].lOpenCom2,hl[def].OpenCom2,shl_OPC2,hl[def].SymbolT,isCase);
          }
        else
        if (strncasecmp(b,"CloseComment2",13)==0)
          {
           pos=MoveAfterEqual(b);
           GetUpTo(4,pos,hl[def].CloseCom2,hl[def].lCloseCom2);
           PutInTables(hl[def].lCloseCom2,hl[def].CloseCom2,shl_CLOSE2,hl[def].SymbolT,isCase);
          }
        else
        if (strncasecmp(b,"EOLComment1",11)==0)
          {
           pos=MoveAfterEqual(b);
           GetUpTo(4,pos,hl[def].EOLCom1,hl[def].lEOLCom1);
           PutInTables(hl[def].lEOLCom1,hl[def].EOLCom1,shl_EOL,hl[def].SymbolT,isCase);
          }
        else
        if (strncasecmp(b,"EOLComment2",11)==0)
          {
           pos=MoveAfterEqual(b);
           GetUpTo(4,pos,hl[def].EOLCom2,hl[def].lEOLCom2);
           PutInTables(hl[def].lEOLCom2,hl[def].EOLCom2,shl_EOL,hl[def].SymbolT,isCase);
          }
        else
        if (strncasecmp(b,"HexMarker",9)==0)
          {
           int i_l;
           pos=MoveAfterEqual(b);
           GetUpTo(4,pos,hl[def].HexStart,hl[def].lHexStart);
           if (!isCase)
              for (i_l=0; i_l<4; i_l++)
                  hl[def].HexStart[i_l]=uctoupper(hl[def].HexStart[i_l]);
          }
        else
        if (strncasecmp(b,"Symbols1",8)==0)
          {
           pos=MoveAfterEqual(b);
           FillTableWith(pos,hl[def].SymbolT,shl_SYM1);
          }
        else
        if (strncasecmp(b,"Symbols2",8)==0)
          {
           pos=MoveAfterEqual(b);
           FillTableWith(pos,hl[def].SymbolT,shl_SYM2);
          }
        else
        if (strncasecmp(b,"String1",7)==0)
          {
           pos=MoveAfterEqual(b);
           FillTableWith(pos,hl[def].SymbolT,shl_STR1);
          }
        else
        if (strncasecmp(b,"String2",7)==0)
          {
           pos=MoveAfterEqual(b);
           FillTableWith(pos,hl[def].SymbolT,shl_STR2);
          }
        else
        if (strncasecmp(b,"Escape",6)==0)
          {
           pos=MoveAfterEqual(b);
           if (*pos && *pos!='\r' && *pos!='\r')
              hl[def].Escape=*pos;
          }
        else
        if (strncasecmp(b,"Preprocessor",12)==0)
          {
           pos=MoveAfterEqual(b);
           if (*pos && *pos!='\r' && *pos!='\r')
              hl[def].Preprocessor=*pos;
          }
        else
        if (strncasecmp(b,"Preprocessor2",12)==0)
          {
           pos=MoveAfterEqual(b);
           if (*pos && *pos!='\r' && *pos!='\r')
              hl[def].Preprocessor2=*pos;
          }
        else
        if (strncasecmp(b,"Case",4)==0)
          {
           pos=MoveAfterEqual(b);
           if (*pos=='1')
             {
              isCase=1;
              hl[def].Flags1|=FG1_CaseSensitive;
             }
          }
        else
        if (strncasecmp(b,"UseInternal",11)==0)
          {
           int i;
           pos=MoveAfterEqual(b);
           i=atoi(pos);
           if (i<0 || i>3)
              i=0;
           TCEditor::SHLTableUse[i]=def;
           hl[def].UseInternal=i;
          }
        else
        if (strncasecmp(b,"Keywords",8)==0)
          {
           pos=MoveAfterEqual(b);
           end=0;
           while (!end)
             {
              for (s=pos; *s && *s!='\n' && *s!='\r' && *s!=','; s++);
              if (*s!=',')
                 end=1;
              if (s!=pos)
                {
                 *s=0;
                 hl[def].Keywords->insert(so.addStr(pos));
                }
              pos=s+1;
             }
          }
        else
        if (strncasecmp(b,"AllowedInsideNames",18)==0)
          {
           pos=MoveAfterEqual(b);
           FillTableWith(pos,hl[def].SymbolT,shl_INSNAME);
          }
        else
        if (strncasecmp(b,"CanStartAName",13)==0)
          {
           pos=MoveAfterEqual(b);
           FillTableWith(pos,hl[def].SymbolT,shl_BEGNAME);
          }
        else
        if (strncasecmp(b,"PMacros",7)==0)
          {
           pos=MoveAfterEqual(b);
           ReplaceCRby0(pos);
           hl[def].PMacros=so.addStr(pos);
          }
        else
        if (strncasecmp(b,"NoCheckNumbers",14)==0)
          {
           pos=MoveAfterEqual(b);
           if (*pos=='1')
              hl[def].Flags1|=FG1_NoNumbers;
          }
        else
        if (strncasecmp(b,"EOLCInFirstCol",14)==0)
          {
           pos=MoveAfterEqual(b);
           if (*pos=='1')
              hl[def].Flags1|=FG1_EOLCInFirstCol;
          }
       }
     while (!feof(f) && strncasecmp(b,"End",3)!=0);
    }
 fclose(f);

 for (def=0; def<defs; def++)
    {
     SETSECreateTables(hl[def].Search,hl[def].Flags1 & FG1_CaseSensitive,hl[def].Keywords);
     for (i=0; i<defs; i++)
         if ((stkHandler)list->at(i)==ConvTable[def])
           {
            ConvTable[def]=i;
            break;
           }
    }

 return 0;
}

// That's just to deallocate all the memory allocated and owned by this module
void UnLoadSyntaxHighLightFile(strSHL *&hl, SOStack *so,
                               TNoCaseSOSStringCollection *list,int &Cant)
{
 int i;

 for (i=0; i<Cant; i++)
    {
     destroy(hl[i].PM);
     destroy(hl[i].Keywords);
     // That's allocated in editorfo.cc by SETSECreateTables
     delete hl[i].Search.firstLetters;
    }
 delete hl;
 if (so)
    delete so;
 destroy(list);
 Cant=0;
 delete ConvTable;
 ConvTable=0;
}

#define MaxExtension 80
extern char *strncpyZ(char *dest, char *orig, int size);

static
int TakeExtension(char *file, char *ext)
{
 char *s=file,*e=0,*e2=0;
 int wasExt=0;

 for (; *s; s++)
     if (*s=='/' || *s=='\\')
        wasExt=0;
     else
        if (*s=='.')
          {
           wasExt++;
           e2=e;
           e=s;
          }

 if (!wasExt)
    return 0;

 // If the extension contains gz and we have 2 extensions use the other
 // it works nice with LFNs, SFNs have 1 extension
 if (wasExt>1 && strstr(e,"gz"))
    strncpyZ(ext,e2+1,min(MaxExtension,e-e2));
 else
    strncpyZ(ext,e+1,MaxExtension);
 return 1;
}

static
int TakeCommentLowLev(char *buffer, int l, char *ext, int &tab_width)
{
 int i;
 char buf[MaxExtension];

 if (l<7)
    return 0;
 l-=2;

 char *s=buffer;
 int p1=-1,p2=-1;

 for (i=0; i<l; i++)
    {
     if (s[i]=='-' && s[i+1]=='*' && s[i+2]=='-')
       {
        if (p1==-1)
          {
           p1=i;
           i+=2;
          }
        else
          if (p2==-1)
            {
             p2=i;
             break;
            }
       }
    }
 if (p2==-1)
    return 0;

 for (p1+=3; ucisspace(s[p1]); p1++);
 for (p2--;  ucisspace(s[p2]); p2--);

 l=p2-p1+2;
 if (l<2)
    return 0;

 if (l>MaxExtension)
    l=MaxExtension;

 strncpyZ(ext,&s[p1],l);
 strcpy(buf,ext);
 // Make a little bit of parsing here
 s=strstr(buf,"mode:");
 if (s)
   {
    s+=5;
    for (;*s && ucisspace(*s); s++);
    char *end=s;
    for (;*end && (ucisalnum(*end) || *end=='-' || *end=='-'); end++);
    *end=0;
    strcpy(ext,s);
    *end=';';
   }
 s=strstr(buf,"tab-width:");
 if (s)
   {
    s+=10;
    for (;*s && ucisspace(*s); s++);
    char *end;
    int temp=strtol(s,&end,0);
    if (temp>0 && temp<32) // Tabs>32 looks like an error, no?
       tab_width=temp;
   }
 return 1;
}

const int searchFromStart=1000, searchAtEnd=3000;

static
int TakeCommentEmacs(char *buffer, int lenBuf, char *ext, int &tab_width)
{
 int len,start;

 /* Don't borther with empty buffers */
 if (!buffer || lenBuf<7)
    return 0;

 /* First 1Kb or available */
 start=0;
 len=searchFromStart;
 if (lenBuf<len)
    len=lenBuf;

 if (TakeCommentLowLev(buffer+start,len,ext,tab_width))
    return 1;

 /* If we searched in all the buffer give up */
 if (lenBuf<=searchFromStart)
    return 0;

 /* Last 3Kb or available */
 start=lenBuf-searchAtEnd;
 if (start<searchFromStart)
    start=searchFromStart;

 return TakeCommentLowLev(buffer+start,lenBuf-start,ext,tab_width);
}


static
int TakeLocalVarLowLev(char *buffer, int lenBuf, char *ext)
{
 unsigned lv,mode,end,i;
 char *s=buffer;

 if (!buffer || lenBuf<25)
    return 0;

 // Search these magic words, quit if one isn't there, ensure they are in the right
 // order
 lv=TCEditor_scan(s,lenBuf,"Local Variables:");
 if (lv==sfSearchFailed)
    return 0;

 lenBuf-=lv;
 s+=lv;
 if (lenBuf<5)
    return 0;
 mode=TCEditor_scan(s,lenBuf,"mode:");
 if (mode==sfSearchFailed)
    return 0;

 lenBuf-=mode;
 s+=mode;
 if (lenBuf<5)
    return 0;
 end=TCEditor_scan(s,lenBuf,"End:");
 if (end==sfSearchFailed)
    return 0;

 s=buffer+lv+mode+5;
 for (i=0; i<MaxExtension-1 && s[i]!='\n' && s[i]!='\r'; i++)
     ext[i]=s[i];
 ext[i]=0;
 return 1;
}

static
int TakeCommentLocalVars(char *buffer, int lenBuf, char *ext)
{
 int start;

 /* Last 3Kb or available */
 start=lenBuf-searchAtEnd;
 if (start<0)
    start=0;

 return TakeLocalVarLowLev(buffer+start,lenBuf-start,ext);
}

static
int TakeComment(char *buffer, int lenBuf, char *ext, int &tab_width)
{
 if (TakeCommentEmacs(buffer,lenBuf,ext,tab_width))
    return 1;
 return TakeCommentLocalVars(buffer,lenBuf,ext);
}

static int IsInList(char *list, char *val)
{
 int l=strlen(list)+1;

 char buf[l];
 strcpy(buf,list); // Because strtok fucks the string

 char *tok=strtok(buf,",");

 while (tok)
   {
    if (strcmp(tok,val)==0)
       return 1;
    tok=strtok(NULL,",");
   }
 return 0;
}

extern const char *GetVariable(const char *variable);

static
int SearchSHLForIt(TCEditor &e, char *Extension, int &index)
{
 char EnvName[MaxExtension+10];
 const char *v;
 int i;

 if (Extension[0]==0)
    return 0;
 else
   {
    // Search if the user overwritten the roules with an envirom. var.
    strcpy(EnvName,"SET_SHL.");
    strcat(EnvName,Extension);
    if ((v=GetVariable(EnvName))!=NULL)
      {
       for (i=0; i<e.SHLCant; i++)
          {
           if (strcmp(e.SHLGenList->atStr(ConvTable[i]),(char *)v)==0)
             {
              index=i;
              return 1;
             }
          }
      }
    // User defined
    for (i=0; i<e.SHLCant; i++)
       {
        if (IsInList(e.SHLSOStack->GetStrOf(e.SHLArray[i].Extentions),Extension))
          {
           index=i;
           return 1;
          }
       }
   }
 return 0;
}

int SHLSelect(TCEditor &e, char *buffer, int lenBuf)
{
 int i,found=0,tab_width=-1;
 char Extension[MaxExtension];
 Extension[0] = 0; // this must be initialized !!

 // In case the editor isn't locked is better to lock it to avoid multiple
 // redraws, for example because a SHL change and a tab size change
 e.lock();
 int oldTab=e.tabSize;
 e.SHLValueSelected=-1;
 // First try using Emacs style syntax highlight methode
 if (TakeComment(buffer,lenBuf,Extension,tab_width))
    found=SearchSHLForIt(e,Extension,i);

 if (!found)
   {
    // If not present then try with the extention
    TakeExtension(e.fileName,Extension);
    found=SearchSHLForIt(e,Extension,i);
   }

 if (found)
   {
    if (e.SHLArray[i].UseInternal)
       e.SetHighlightTo((shlState)e.SHLArray[i].UseInternal);
    else
       e.SetHighlightTo(shlGenericSyntax,i);
    e.SHLValueSelected=i;
   }
 else
   e.SetHighlightTo(shlNoSyntax);

 if (tab_width>0 && tab_width!=oldTab)
   {
    e.tabSize=tab_width;
    e.update(ufView);
   }
 e.unlock();

 return found;
}

PMacroStr *SHLSearchPMTrigger(char *trg);

