#!/usr/bin/perl
# Copyright (C) 1996,1997,1998,1999 by Salvador E. Tropea (SET),
# see copyrigh file for details
#
open(FIL,'../../version.txt') || return 0;
$version=<FIL>;
chop($version);
close(FIL);
$version1=$version;
$version1=~ s/\.//g;

$binManifest='';

# Default prefix
$pwd=`pwd`;
chop($pwd);
$prefix=$pwd;
# Environment prefix
$i=$ENV{'prefix'};
if (length($i))
  {
   $prefix=$i;
  }
else
  {
   $i=$ENV{'PREFIX'};
   if (length($i))
     {
      $prefix=$i;
     }
  }

# Parse command line
$nextisprefix=0;
$iMode=0;  # Installation mode
foreach $i (@ARGV)
  {
   if ($nextisprefix)
     {
      $prefix=$i;
      $nextisprefix=0;
     }
   elsif ($i eq '--prefix')
     {
      $nextisprefix=1;
     }
   elsif ($i eq '--install')
     {
      $iMode=1;
     }
   else
     {
      print "Unknown command line option: $i\n";
      print "Usage: compres.pl [--prefix path] [--install]\n\n";
     }
  }

@files=('../../distrib/distrib1.txt','../../distrib/distrib2.txt');


# Update the makefiles if needed
if (!$iMode)
  {
   print "Creating makefile: ";
   system('cp -p ../djgppenv.env ../rhide.env');
   chdir('..');
   system('make makes');
   chdir('djgpp');
   print "done.\n\n";
  }


# Create the distribution tree if needed
print "Creating directories: \n";

if ($iMode)
  {
   # Installation directories
   $bindir    =$prefix.'/bin';
   $contrib1  =$prefix.'/contrib';
   $contrib   =$contrib1.'/setedit.bin';
   $info      =$prefix.'/info';
   $share1    =$prefix.'/share';
   $share     =$share1.'/setedit';
   $manifest  =$prefix.'/manifest';

   @tree=(
   $bindir,
   $contrib1,
   $contrib,
   $info,
   $share1,
   $share,
   $manifest);
  }
else
  {
   # Distribution directories
   $distPrefix=$prefix.'/distrib';
   $bindir    =$distPrefix.'/bin';
   $contrib1  =$distPrefix.'/contrib';
   $contrib   =$contrib1.'/setedit.bin';
   $info      =$distPrefix.'/info';
   $share1    =$distPrefix.'/share';
   $share     =$share1.'/setedit';
   $manifest  =$distPrefix.'/manifest';
   $result    =$prefix.'/result';
   
   @tree=(
   $distPrefix,
   $bindir,
   $contrib1,
   $contrib,
   $info,
   $share1,
   $share,
   $manifest,
   $result);
  }

foreach $i (@tree)
  {
   if (!(-d $i))
     {
      mkdir($i,00755);
      print "$i\n";
     }
  }
print "done.\n\n";


print "Copying the exe: ";
$d=$bindir.'/setedit.exe';
$o='../editor.exe';
$binManifest.=$d."\n";
if (!(-e $d) or (-M $d > -M $o))
  {
   system("cp -p $o .");
   system("zip -9u $result/dbgcopy.zip editor.exe") unless($iMode);
   # I could use --best but is slooooowwwwwwwww and doesn't compress much in
   # the case of the editor.
   system('upx -9 editor.exe');
   system("mv editor.exe $d");
  }
print "done.\n\n";


print "Copying the batch: ";
$d=$bindir.'/e.bat';
$o='../../distrib/arranca.bat';
CopyIf($o,$d,$binManifest);
print "done.\n\n";


print "Copying share files: ";
@cfgs=('../../cfgfiles/*.pmc','../../cfgfiles/*.shl','../../cfgfiles/*.tip',
       '../../fonts/*.sft','../../sdg/txhgen-i.*','../../sdg/*.frt',
       '../../cfgfiles/menubind.smn','../../cfgfiles/redmond.smn',
       '../../cfgfiles/*.slp');
foreach $i (@cfgs)
  {
   @a=glob($i);
   foreach $o (@a)
     {
      $o =~ /.*\/(.*)/;
      $d = $share.'/'.$1;
      print $1.' ' if (CopyIf($o,$d,$binManifest));
     }
  }
print "done.\n\n";


print "Copying doc files: ";
chdir('../../doc');
if (system('make txt info')==0)
  {
   CopyIf('editor.inf',$info.'/setedit.inf',$binManifest);
   CopyIf('sdg.inf',$info.'/sdg.inf',$binManifest);
   CopyIf('infeng.inf',$info.'/infview.inf',$binManifest);
   CopyIf('editor.txt',$contrib.'/setedit.txt',$binManifest);
   CopyIf('sdg.txt',$contrib.'/sdg.txt',$binManifest);
   CopyIf('infeng.txt',$contrib.'/infview.txt',$binManifest);
  }
else
  {
   print "\n************* Attention!! *************\n\n";
   print "Failed to generate the docs ... Skipping the documentation,\n";
   print "you can create it latter, now press ENTER or ^C to stop\n";
   <STDIN>;
  }
chdir('../makes/djgpp');
CopyIfRpl('../../distrib/distrib1.txt',$contrib.'/readme.1st',$binManifest);
print "done.\n\n";


print "Copying other files: ";
print 'example.zip ' if (CopyIf('../../distrib/kextend.zip',$contrib.'/kextend.zip',$binManifest));
print 'kexpand.zip ' if (CopyIf('../../distrib/example.zip',$contrib.'/example.zip',$binManifest));
print 'change.log '  if (CopyIf('../../change.log',$contrib.'/change.log',$binManifest));
print 'copyrigh'     if (CopyIf('../../copyrigh',$contrib.'/copyrigh',$binManifest));
print 'copying.dj'   if (CopyIf('../../copying.dj',$contrib.'/copying.dj',$binManifest));
print 'copying.gpl'  if (CopyIf('../../copying.gpl',$contrib.'/copying.gpl',$binManifest));
print 'copying.lgp'  if (CopyIf('../../copying.lgp',$contrib.'/copying.lgp',$binManifest));
print 'copying.rh'   if (CopyIf('../../copying.rh',$contrib.'/copying.rh',$binManifest));
print 'windos.faq'   if (CopyIf('../../windos.faq',$contrib.'/readme.faq',$binManifest));
print "done.\n\n";


print "Generating manifest and version files: \n";
$d="$manifest/edi$version1"."b.ver";
open(FIL,">$d") || die "Can't create version file";
print FIL ("edi".$version1."b SET's editor v$version for DJGPP");
close(FIL);
$binManifest.="$d\n";
$d="$manifest/edi$version1"."b.mft";
$binManifest.="$d\n";
if ($iMode)
  {
   $prefix.='/';
   $binManifest =~ s/$prefix//g;
  }
else
  {
   $i="$distPrefix/";
   $binManifest =~ s/$i//g;
  }
open(FIL,">$d");
print FIL ($binManifest);
close(FIL);
print "done.\n\n";


if ($iMode)
  {
   die "End of installation\n";
  }


print "Compressing the files: ";
$i=`pwd`;
chop($i);
chdir($distPrefix);
system("zip -9r $result/edi".$version1."b.zip *");
chdir($i);
print "done.\n\n";


CopyIfRpl('../../distrib/distrib1.txt',"$result/readme.1st");
CopyIfRpl('../../distrib/distrib2.txt',"$result/announce.txt");


print "\n\nCreating source distribution\n";
$srcmft="manifest/edi$version1".'s.mft';
$srcver="manifest/edi$version1".'s.ver';


chdir('../../../..');

open(FIL,'contrib/setedit/makes/lista');
@files=<FIL>;
close(FIL);
$r='';
foreach $i (@files)
  {
   $a=substr($i,0,1);
   if (($a eq '-') or ($a eq '+') or ($a eq '*'))
     {
      $i=substr($i,1);
     }
   $r.='contrib/setedit/'.$i;
  }
open(FIL,'contrib/setedit/makes/listaxtr');
@files=<FIL>;
close(FIL);
foreach $i (@files)
  {
   chop($i);
   $r.=join("\r",glob('contrib/setedit/'.$i))."\r";
  }
$r.="$srcmft\n$srcver\n";
replace($srcmft,$r);
replace($srcver,"edi".$version1."s SET's editor v$version for DJGPP");


# Generate the zip files
$srcdist="edi$version1".'s.zip';
unlink($srcdist);
system("zip -9 $result/$srcdist \@$srcmft");

chdir('contrib/setedit/makes/djgpp');



sub cat
{
 local $/;
 my $b;

 open(FIL,$_[0]) || return 0;
 $b=<FIL>;
 close(FIL);

 $b;
}


sub replace
{
 my $b=$_[1];

 open(FIL,">$_[0]") || return 0;
 print FIL ($b);
 close(FIL);
}


sub CopyIf
{
 my ($o,$d)=@_;
 my $list=\$_[2];

 $$list.=$d."\n";
 if (!(-e $d) or (-M $d > -M $o))
   {
    system("cp -p $o $d");
    return 1;
   }
 0;
}


sub CopyIfRpl
{
 my ($o,$d)=@_;
 my $a;
 my $list=\$_[2];

 $$list.=$d."\n";
 if (!(-e $d) or (-M $d > -M $o))
   {
    $a=cat($o);
    $a =~ s/\@\@v\@\@/$version/g;
    $a =~ s/\@\@v1\@\@/$version1/g;
    replace($d,$a);
    return 1;
   }
 0;
}
