# Copyright (C) 1996,1997,1998,1999 by Salvador E. Tropea (SET),
# see copyrigh file for details
#
#!/usr/bin/perl
#
#   This perl script reads the rhide.env file and replaces all the
# definitions of this file in the known .mak files. Only the needed
# definitions are patched, it means I don't replace a definition that is 100%
# equal to the new one. Additionally the .mak file is stored in disk only if
# it was changed.
#   The script prints a . for each search, a + for a one line replace and a
# * for a multiline replace.
#
@files=('amp3','easydiag','editor','extra','inffd','librhuti','libset',
        'sdgcline','settv','testeasy');

# Get the current rhide.env
open(FIL,'rhide.env') || die 'Hey! where is rhide.env?';
@vars=<FIL>;
close(FIL);

# Patch the environment variables
foreach $i (@files)
  {
   $i.='.mak';
   print 'Processing '."$i: ";
   $r=&cat($i);
   $changes=0;
   foreach $search (@vars)
     {
      # Skip comments
      next if (substr($search,0,1) eq '#');
      # Get the name of the variable
      if ($search =~ /(.*)=(.*)/)
        {
         $name=$1;
         $value=$2;
         print '.';
        }
      else
        {
         next; #?
        }

      $repl="^$name"."=((.+\\\\\\n)+(.+))";
      if (($r =~ /$repl/m) && ($1 ne $value))
        { # Ok multiline
         #print "\nReplacing:\n>$repl<\n>$1<\n>$name=$value<\n";
         $r =~ s/$repl/$name=$value/mg;
         print '*';
         $changes++;
        }
      else
        { # Single line
         $repl="^$name"."=(.+)";
         if (($r =~ /$repl/m) && ($1 ne $value))
           {
            $r =~ s/$repl/$name=$value/mg;
            print '+';
            $changes++;
           }
        }
     }
   if ($changes)
     {
      replace($i,$r);
      print ' updated ';
     }
   print "\n";
  }

sub cat
{
 local $/;
 my $b;

 open(FIL,$_[0]) || return 0;
 $b=<FIL>;
 close(FIL);

 $b;
}

sub replace
{
 my $b=\$_[1];

 open(FIL,">$_[0]") || return 0;
 print FIL ($$b);
 close(FIL);
}


