/* Copyright (C) 1996,1997,1998,1999 by Salvador E. Tropea (SET),
   see copyrigh file for details */
#include <stdio.h>
#include <string.h>

#define Uses_MsgBox
#define Uses_TDialog
#define Uses_TRadioButtons
#define Uses_TButton
#define Uses_TSItem
#define Uses_TLabel
#define Uses_TRect
#define Uses_TProgram
#define Uses_TDeskTop
#define Uses_TScreen
#define Uses_TInputLine
#define Uses_TSortedListBox
#define Uses_TScrollBar
#define Uses_TStringCollection
#define Uses_TCheckBoxes
#define Uses_TCEditor
#define Uses_TDeskTopClock
#define Uses_TApplication
#define Uses_TCEditWindow
#define Uses_TStaticText

// EasyDiag requests
#define Uses_TSButton
#define Uses_TSLabelRadio
#define Uses_TSLabelCheck
#define Uses_TSRadioButtons
#define Uses_TSInputLine
#define Uses_TSVeGroup
#define Uses_TSSortedListBox
#define Uses_TSHzGroup
#define Uses_TSCheckBoxes
#define Uses_TSHzLabel
#define Uses_TSStaticText

// First include creates the dependencies
#include <easydia1.h>
#include <ceditor.h>
// Second request the headers
#include <easydiag.h>

#include <diaghelp.h>
#include <stdlib.h>
#define Uses_SETAppVarious
#define Uses_SETAppDialogs
#define Uses_TSetEditorApp
#define Uses_SETAppConst
#include <setapp.h>
#include <codepage.h>

// Forced width of the encodings and fonts list boxes
const int wForced=24;

/**[txh]********************************************************************

  Description:
  That's common between DOS and Linux.

***************************************************************************/

static
void PrimaryEncoding(TSSortedListBox *&enco1, TSLabel *&lbe1, int disableFonts)
{
 //-------------- Encoding Primary -------------------
 enco1=new TSSortedListBox(wForced,6,tsslbVertical);
 lbe1=new TSLabel(disableFonts ? _("No fonts found") : _("Primary ~e~ncoding"),enco1);
 //----------- End of Encoding Primary ---------------
}


#ifndef __DJGPP__

TDialog *CreateScreenOpsDialog()
{
 TSViewCol *col=new TSViewCol(new TDialog(TRect(1,1,1,1),_("Screen Options")));

 TSSortedListBox *enco1;
 TSLabel *lbe1;
 PrimaryEncoding(enco1,lbe1,0);

 col->insert(2,2,lbe1);
 EasyInsertOKCancel(col);

 TDialog *d=col->doIt();
 delete col;

 d->options|=ofCentered;
 d->helpCtx=cmeSetScreenOps;
 return d;
}

#pragma pack(1)
typedef struct
{
 TCollection *font_enco  __attribute__((packed));
 ccIndex font_encs       __attribute__((packed));
} ScreenBox;
#pragma pack()

void SetScreenOps(void)
{
 ccIndex oldE1;
 char setDta=1;

 ScreenBox box;
 box.font_enco=GetCodePagesList();
 oldE1=box.font_encs=CodePageIDToIndex(GetCodePageFont(1));

 TDialog *d=CreateScreenOpsDialog();

 if (execDialogNoDestroy(d,&box,setDta)==cmOK)
   {
    if (oldE1!=box.font_encs)
      {
       ChangeEncodingOfFont(1,IndexToCodePageID(box.font_encs));
       ResetVideoMode(TScreen::screenMode);
      }
   }

 destroy(d);
}

#else
#include <tpaltext.h>

extern void InsertEnviromentVar(char *variable,char *contents);
extern void setIntenseState(void);
// From edfonts.cc
TStringCollection *CreateListOfFonts(char *dir, ushort &IsPrimOn, ccIndex &indexPrim,
                                     ushort &IsSecoOn, ccIndex &indexSeco);
extern const char *GetVariable(const char *variable);

const ushort OtherOp=13;

TDialog *CreateScreenOpsDialog(int disableFonts)
{
 TSViewCol *col=new TSViewCol(new TDialog(TRect(1,1,1,1),_("Screen Options")));

 //------------ Video mode stuff ------------------
 TSLabel *mode=TSLabelRadio(__("~S~creen mode"),
          "8~0~x25",  // 0x003 8/9x16 VGA
          "80x~2~8",  // 0x103        VGA+scanlines
          "~8~0x35",  // 0x203
          "80x~4~0",  // 0x303
          "80x4~3~",  // 0x403 8x8
          "80x~5~0",  // 0x503 8/9x8
          "80x30",    // 0x703 8x16   VGA+tweaked
          "80x34",    // 0x803 8x14
          "90x30",    // 0x903 8x16
          "90x34",    // 0xA03 8x14
          "94x30",    // 0xB03 8x16
          "94x34",    // 0xC03 8x14
          "82x25",    // 0xD03 8x16 fonts
          __("other"),0);
 // Other mode
 TSInputLine *other=new TSInputLine(10);
 TSVeGroup *Mode=new TSVeGroup(mode,other,0);
 Mode->makeSameW();
 //-------- End of Video mode stuff ---------------

 //---------------- Primary Font ---------------------
 TSLabel *font=TSLabelRadio(disableFonts ? __("No fonts found") :
                                           __("~P~rimary font (intense)"),
                            __("~R~OM BIOS fonts"),_("O~t~her font"),0);
 TSSortedListBox *lb=new TSSortedListBox(wForced,4,tsslbVertical);
 TSVeGroup *PFont=new TSVeGroup(font,lb,0);
 PFont->makeSameW();
 //------------ End of Primary Font ------------------

 //---------------- Secondary Font -------------------
 TSLabel *font2=TSLabelRadio(disableFonts ? __("No fonts found") :
                                            __("~S~econdary font"),
                             __("~D~on't use it"),_("O~t~her font"),0);
 TSSortedListBox *lb2=new TSSortedListBox(wForced,4,tsslbVertical);
 TSVeGroup *SFont=new TSVeGroup(font2,lb2,0);
 SFont->makeSameW();
 //------------ End of Secondary Font ----------------

 //-------------- Encoding Primary -------------------
 TSSortedListBox *enco1;
 TSLabel *lbe1;
 PrimaryEncoding(enco1,lbe1,disableFonts);
 //----------- End of Encoding Primary ---------------

 //-------------- Encoding Secondary -----------------
 TSSortedListBox *enco2=new TSSortedListBox(wForced,6,tsslbVertical);
 TSLabel *lbe2=new TSLabel(disableFonts ? _("No fonts found") :
                                          _("Secondary encoding"),enco2);
 //----------- End of Encoding Secondary -------------

 //----------- External video mode -------------------
 TSHzGroup *ext=new TSHzGroup(new TSCheckBoxes(new TSItem(_("Use external program"),0)),
                              new TSInputLine(80,36),
                              0);
 ext->ySep=0;
 //--------- End of External video mode --------------

 if (disableFonts)
   {
    ((TSRadioButtons *)(font->linked))->view->options&=~ofSelectable;
    lb->view->options&=~ofSelectable;
    ((TSRadioButtons *)(font2->linked))->view->options&=~ofSelectable;
    lb2->view->options&=~ofSelectable;
    enco1->view->options&=~ofSelectable;
    enco2->view->options&=~ofSelectable;
   }

 col->insert(2,1,Mode);
 col->insert(xTSRightOf,1,PFont,Mode);
 col->insert(xTSRightOf,yTSUnder,SFont,Mode,PFont);
 col->insert(xTSRightOf,1,lbe1,PFont);
 col->insert(xTSRightOf,yTSUnder,lbe2,SFont,lbe1);
 col->insert(2,yTSUnder,ext,0,Mode);
 EasyInsertOKCancel(col);

 TDialog *d=col->doIt();
 delete col;

 d->options|=ofCentered;
 d->helpCtx=cmeSetScreenOps;
 return d;
}

#pragma pack(1)
typedef struct
{
 ushort mode             __attribute__((packed));
 char   other[10]        __attribute__((packed));
 ushort font_flg         __attribute__((packed));
 TCollection *font_list  __attribute__((packed));
 ccIndex font_sel        __attribute__((packed));
 ushort font2_flg        __attribute__((packed));
 TCollection *font2_list __attribute__((packed));
 ccIndex font2_sel       __attribute__((packed));
 TCollection *font_enco  __attribute__((packed));
 ccIndex font_encs       __attribute__((packed));
 TCollection *font2_enco __attribute__((packed));
 ccIndex font2_encs      __attribute__((packed));
 ushort ext_prg          __attribute__((packed));
 char   command[80]      __attribute__((packed));
} ScreenBox;
#pragma pack()

static
ushort ModeToOption(ushort mode)
{
 if ((mode & 0xFF)==3)
   {
    ushort m=mode>>8;
    if (m>5)
       m--;
    if (m>12)
       return OtherOp;
    return m;
   }
 return OtherOp;
}

static
ushort OptionToMode(ScreenBox &box)
{
 char *end;

 if (box.mode==OtherOp)
    return strtol(box.other,&end,0);
 if (box.mode>5)
    box.mode++;
 return box.mode<<8 | 3;
}


void SetScreenOps(void)
{
 int repeat=1,fontChanged=0;
 ushort oldmode=TScreen::screenMode;
 ushort oldFontFlg,oldFont2Flg;
 ccIndex oldFontSel,oldFont2Sel,oldE1,oldE2;
 char setDta=1,extChange;

 ScreenBox box;
 box.mode=ModeToOption(oldmode);
 sprintf(box.other,"0x%03X",oldmode);
 box.font_list=box.font2_list=CreateListOfFonts((char *)GetVariable("SET_FILES"),
                                                box.font_flg,box.font_sel,box.font2_flg,
                                                box.font2_sel);
 box.font_enco=box.font2_enco=GetCodePagesList();
 oldE1=box.font_encs=CodePageIDToIndex(GetCodePageFont(1));
 oldE2=box.font2_encs=CodePageIDToIndex(GetCodePageFont(2));

 oldFontFlg=box.font_flg;
 oldFontSel=box.font_sel;
 oldFont2Flg=box.font2_flg;
 oldFont2Sel=box.font2_sel;
 TDialog *d=CreateScreenOpsDialog(box.font_list->getCount()==0);
 box.ext_prg=TSetEditorApp::UseExternPrgForMode;
 strcpy(box.command,TSetEditorApp::ExternalPrgMode);

 while (repeat)
   {
    repeat=0;
    if (execDialogNoDestroy(d,&box,setDta)==cmOK)
      {
       if (oldFontSel!=box.font_sel || oldFontFlg!=box.font_flg ||
           oldFont2Flg!=box.font2_flg || oldFont2Sel!=box.font2_sel)
         {
          fontChanged=1;
          if (box.font_flg==0) // ROM?
             LoadEditorFonts(0,0,IndexToCodePageID(box.font_encs),
                             IndexToCodePageID(box.font2_encs));
          else
            {
             char *p=(char *)(box.font_list->at(box.font_sel));
             p+=strlen(p)+1;
             char *s=0;
             if (box.font2_flg==1)
               {
                s=(char *)(box.font2_list->at(box.font2_sel));
                s+=strlen(s)+1;
               }
             LoadEditorFonts(p,s,IndexToCodePageID(box.font_encs),
                             IndexToCodePageID(box.font2_encs));
            }
         }
       else
       if (oldE1!=box.font_encs || oldE2!=box.font2_encs)
         {
          if (oldE1!=box.font_encs)
            {
             ChangeEncodingOfFont(1,IndexToCodePageID(box.font_encs));
             fontChanged=1;
            }
          if (oldE2!=box.font2_encs)
            {
             ChangeEncodingOfFont(2,IndexToCodePageID(box.font2_encs));
             fontChanged=1;
            }
         }
       extChange=strcmp(TSetEditorApp::ExternalPrgMode,box.command)!=0;
       strcpy(TSetEditorApp::ExternalPrgMode,box.command);
       if (TSetEditorApp::UseExternPrgForMode!=box.ext_prg ||
           (box.ext_prg && extChange))
          fontChanged=1; // Not the font but force it ;-)
       TSetEditorApp::UseExternPrgForMode=box.ext_prg;

       ushort newmode=OptionToMode(box);
       if (oldmode!=newmode || fontChanged)
         {
          if (ResetVideoMode(newmode))
            {
             messageBox(mfError | mfOKButton,_("This video mode (0x%03x) is not"
                        " supported by the Turbo Vision library"),newmode);
             repeat=1;
             //fprintf(stderr,"Modo no soportado: %03x, segn TV: %03x\n",newmode,TScreen::screenMode);
            }
         }
      }
   }

 destroy(box.font_list);
 destroy(d);
}
#endif

#pragma pack(1)
typedef struct
{
 ushort ops          __attribute__((packed));
 ushort clk_on       __attribute__((packed));
 ushort clk_mode     __attribute__((packed));
 char   editors[5]   __attribute__((packed));
 ushort scr_on       __attribute__((packed));
 TCollection *savers __attribute__((packed));
 ccIndex scr_sel     __attribute__((packed));
 char    time[5]     __attribute__((packed));
} BoxGral;
#pragma pack()

void SetGeneralEditorOptions(void)
{
 /* Here is a very good example of EasyDiag, the dialog is as good of the one
    made by hand but the code is much more simple. The routine exploits the
    horizontal and vertical group properties */
 // BCMORSTY
 TSViewCol *col=new TSViewCol(new TDialog(TRect(1,1,1,1),_("Global editor options")));

 TSLabel *tcb=TSLabelCheck(__("~S~ave options"),
              __("Make ~b~ackups"),
              __("Don't create desktop files"),
 #ifdef __DJGPP__
              __("Save UNIX files as UNIX"),
 #endif
              0);

 TSHzGroup *Clock=new TSHzGroup(TSLabelRadio(__("~C~lock"),__("OFF"),__("ON"),0),
                                TSLabelRadio(__("St~y~le"),__("AM/PM"),__("24 hs"),0));

 TSHzLabel *MaxEds=new TSHzLabel(_("~M~ax. editor copies"),new TSInputLine(5));

 TSVeGroup *FirstCol=new TSVeGroup(tcb,new TSVeGroup(Clock,MaxEds,0),0);
 FirstCol->makeSameW();

 TSLabel *scrv=TSLabelRadio(__("Sc~r~een saver (?)"),__("OFF"),__("ON"),0);
 TSSortedListBox *lb2=new TSSortedListBox(24,4,tsslbVertical);
 TSVeGroup *Scrv=new TSVeGroup(scrv,lb2,0);
 Scrv->makeSameW();

 TSHzLabel *timeL=new TSHzLabel(_("~T~ime"),new TSInputLine(5));
 TSStaticText *seconds=new TSStaticText(_("seconds"));
 TSHzGroup *Time=new TSHzGroup(timeL,seconds);

 TSVeGroup *ScreenSaver=new TSVeGroup(Scrv,Time,0);

 col->insert(2,1,FirstCol);
 col->insert(xTSRightOf,1,ScreenSaver,FirstCol);
 EasyInsertOKCancel(col,4);

 TDialog *d=col->doIt();
 delete col;
 d->options|=ofCentered;
 d->helpCtx=cmeEdGralOptions;

 BoxGral box;
 memset(&box,0,sizeof(BoxGral));

 if (TCEditor::editorFlags & efBackupFiles)
    box.ops|=1;
 if (TCEditor::editorFlags & efSaveUNIXasis)
    box.ops|=4;

 // To avoid filling the disk with .dst files
 char *s=(char *)GetVariable("SET_CREATE_DST");
 if (!s || atoi(s)==0)
    box.ops|=2;

 box.clk_on=TSetEditorApp::ShowClock;
 box.clk_mode=TDeskTopClock::mode;
 box.scr_on=TSetEditorApp::UseScreenSaver;

 char buf[20];
 sprintf(buf,"%d",TSetEditorApp::screenSaverTime);
 strncpy(box.time,buf,4);

 sprintf(buf,"%d",TSetEditorApp::maxOpenEditorsSame);
 strncpy(box.editors,buf,4);

 box.savers=GetScreenSaverList();
 ccIndex w;
 if (TSetEditorApp::WhichScrSaver &&
     ((TStringCollection *)box.savers)->search(TSetEditorApp::WhichScrSaver,w))
    box.scr_sel=w;
 else
    box.scr_sel=0;

 if (execDialog(d,&box.ops)==cmOK)
   {
    if (box.ops & 1)
       TCEditor::editorFlags|=efBackupFiles;
    else
       TCEditor::editorFlags&=~efBackupFiles;
    sprintf(buf,"%d",!(box.ops & 2));
    InsertEnviromentVar("SET_CREATE_DST",buf);
    if (box.ops & 4)
       TCEditor::editorFlags|=efSaveUNIXasis;
    else
       TCEditor::editorFlags&=~efSaveUNIXasis;
    TSetEditorApp::ShowClock=box.clk_on;
    TDeskTopClock::mode=box.clk_mode;
    TSetEditorApp::UseScreenSaver=box.scr_on;
    delete TSetEditorApp::WhichScrSaver;
    TSetEditorApp::WhichScrSaver=strdup((char *)(box.savers->at(box.scr_sel)));
    TSetEditorApp::screenSaverTime=atoi(box.time);
    TSetEditorApp::maxOpenEditorsSame=atoi(box.editors);
    /* Avoid dangerous values */
    if (TSetEditorApp::maxOpenEditorsSame<1)
       TSetEditorApp::maxOpenEditorsSame=1;
   }
}

